mod Ex01b

incl Mtex

loc rem 
  \para \bf  1. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 22.2.2017 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1617ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para deklaratívne programovanie: explicitné definície a primitívna 
         rekurzia, 
   \item \para výroková logika a výrokovo-logické vyplývanie. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end Identifier conventions: 
  \items 
   \item \para Variable identifier. A string of lower case letters possibly 
         followed by one or two digits as indices. Examples: \ft x \end, 
         \ft ys \end, \ft i1 \end, \ft foo99 \end. 
   \item \para Function identifier. An alpha-numeric string starting with a 
         capital letter and containing lower case letters, digits, and underline 
         symbols '_'. Examples: \ft F \end, \ft Max \end, 
         \ft Power_of_some_prime \end, \ft A1b2c3 \end. 
  \end

rem 
  \para \bf  [CL] Remark.  \end By a component we mean either remark, or 
  definition or theorem. 

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Explicit Definitions.  \end 

rem 
  \para \bf  Square function.  \end The next component contains the explicit 
  definition of the function \ft Square(x) \end which yields the square 
  \ft Tex_f2_n_exp(x,2) \end of the number \ft x \end. 

fun Square 
  Square(x) = x*x

rem 
  \para \bf  Exercise.  \end Evaluate the square function for some arguments; 
  e.g. execute the query \ft Square(5) = x \end. 

rem 
  \para \bf  Sum of two squares.  \end \header* fun/2 Sum_of_squares  \end Write 
  an explicit definition of the binary function \ft Sum_of_squares(x,y) \end 
  which yields the sum of the squares \ft Tex_f2_n_exp(x,2) \end and 
  \ft Tex_f2_n_exp(y,2) \end. 
  \para \it  Hint.  \end Press the \it  Ins/Del  \end button on the right. 

rem 
  \para \bf  Minimum.  \end \header* fun/2 Min 'Tex_f2_n_min' \end The binary 
  function \ft Min(x,y) \end returns the smaller of its two arguments: 
  \eq* 
    Min(x,y) <= x & Min(x,y) <= y & (Min(x,y) = x \/ Min(x,y) = y)
  \end
  \para The following component contains an explicit \it  clausal  \end 
  definition of the minimum function. 

fun/2 Min 'Tex_f2_n_min'
  Min(x,y) = x <- x <= y
  Min(x,y) = y <- x > y

rem 
  \para \bf  Exercise.  \end Evaluate the function for some arguments. 

rem 
  \para \bf  [CL] Remark.  \end Here is an example of syntactically incorrect 
  definition of the same function: 
  \def 
    fun/2 Min 'Tex_f2_n_min'
    Min(x,y) = x <- x <= y
    Min(a,b) = b <- a > b
  \end
  \para This is because the first application \ft Min(x,y) \end of the minimum 
  function is syntactically different from the second \ft Min(a,b) \end. They 
  should be identical as it is in the previous definition. 

rem 
  \para \bf  Maximum.  \end \header* fun/2 Max 'Tex_f2_n_max' \end Define the 
  binary function \ft Max(x,y) \end which returns the larger of its two 
  arguments: 
  \eq* 
    Max(x,y) >= x & Max(x,y) >= y & (Max(x,y) = x \/ Max(x,y) = y)
  \end

fun/2 Max 'Tex_f2_n_max'
  Max(x,y) = Foo

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Summation.  \end \header* fun Sum 'Tex_f1_n_sum' \end The following 
  component contains a primitive recursive definition of the summation function 
  \ft Sum(n) \end: 
  \eq* 
    Sum(0) = 0
  \end
  \eq* 
    Sum(n+1) = Sum(n)+n+1
  \end

fun Sum 'Tex_f1_n_sum'
  Sum(n) = 0 <- n = 0
  Sum(n) = Sum(n-1)+n <- n != 0

rem 
  \para \bf  Factorial.  \end \header* fun Fact 'Tex_f1_n_fact' \end Define by 
  primitive recursion the factorial function \ft Fact(n) \end: 
  \eq* 
    Fact(0) = 1
  \end
  \eq* 
    Fact(n+1) = (n+1)*Fact(n)
  \end

fun Fact 'Tex_f1_n_fact'
  Fact(n) = Foo

rem 
  \para \bf  Exponentiation.  \end \header* fun/2 Exp 'Tex_f2_n_exp' \end Define 
  by primitive recursion the exponentiation function \ft Exp(x,y) \end: 
  \eq* 
    Exp(x,0) = 1
  \end
  \eq* 
    Exp(x,y+1) = x*Exp(x,y)
  \end

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  [CL] Final remark.  \end Save your solutions and exit the system 
  CL. That is, click the \it  Save & Exit  \end button or type \it  Alt  \end + 
  \it  X  \end. 

